diff -ur slackware64-current.2/source/l/liburing/liburing.SlackBuild slackware64-current.3/source/l/liburing/liburing.SlackBuild
--- slackware64-current.2/source/l/liburing/liburing.SlackBuild	2021-02-13 06:32:00.724945144 +0100
+++ slackware64-current.3/source/l/liburing/liburing.SlackBuild	2021-09-18 13:42:55.237014238 +0200
@@ -78,6 +78,9 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Fix missing MAP_HUGE_2MB on s390x for test program:
+zcat $CWD/missing_map_huge_2mb.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/l/libvpx/libvpx.SlackBuild slackware64-current.3/source/l/libvpx/libvpx.SlackBuild
--- slackware64-current.2/source/l/libvpx/libvpx.SlackBuild	2024-11-02 03:05:46.465008210 +0100
+++ slackware64-current.3/source/l/libvpx/libvpx.SlackBuild	2025-01-07 13:31:27.742873425 +0100
@@ -55,10 +55,21 @@
   SLKCFLAGS="-O2 -march=x86-64 -mtune=generic -fPIC"
   LIBDIRSUFFIX="64"
   ARCHOPTS="--target=x86_64-linux-gcc --enable-pic"
-else
-  SLKCFLAGS="-O2"
+elif [ "$ARCH" = "armv7hl" ]; then
+  ARCHOPTS="--target=armv7-linux-gcc --cpu=cortex-a8"
   LIBDIRSUFFIX=""
-  ARCHOPTS="--target=${ARCH}-linux-gcc"
+  export CC=gcc
+  export LD=gcc
+  export AS=as
+  export AR=ar
+elif [ "$ARCH" = "aarch64" ]; then
+  SLKCFLAGS="-O2"
+  LIBDIRSUFFIX="64"
+  ARCHOPTS="--target=arm64-linux-gcc"
+else
+  SLKCFLAGS=${SLKCFLAGS:-"-O2"}
+  LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+  ARCHOPTS=${ARCHOPTS:-"--target=generic-gnu"}
 fi
 
 TMP=${TMP:-/tmp}
diff -ur slackware64-current/source/l/libwnck/libwnck.SlackBuild slackware64-current.2/source/l/libwnck/libwnck.SlackBuild
--- slackware64-current/source/l/libwnck/libwnck.SlackBuild	2022-10-06 13:46:48.089532642 +0200
+++ slackware64-current.2/source/l/libwnck/libwnck.SlackBuild	2025-06-09 21:05:06.141030691 +0200
@@ -69,6 +69,10 @@
 rm -rf libwnck-$VERSION
 tar xvf $CWD/libwnck-$VERSION.tar.?z* || exit 1
 cd libwnck-$VERSION || exit 1
+
+# Fix against patched libsn (startup-notification) to support time64 on 32 bit platform:
+zcat $CWD/tasklist_time64.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current/source/l/libwnck3/libwnck3.SlackBuild slackware64-current.2/source/l/libwnck3/libwnck3.SlackBuild
--- slackware64-current/source/l/libwnck3/libwnck3.SlackBuild	2025-09-03 22:48:11.787137725 +0200
+++ slackware64-current.2/source/l/libwnck3/libwnck3.SlackBuild	2025-09-07 11:26:45.936963928 +0200
@@ -75,6 +75,9 @@
 tar xvf $CWD/libwnck-${VERSION}.tar.?z || exit 1
 cd libwnck-$VERSION
 
+# Fix against patched libsn (startup-notification) to support time64 on 32 bit platform:
+zcat $CWD/tasklist_time64.diff.gz | patch -p1 --verbose || exit 1
+
 # Make sure ownerships and permissions are sane:
 chown -R root:root .
 find . \
diff -ur slackware64-current/source/l/libwpg/libwpg.SlackBuild slackware64-current.2/source/l/libwpg/libwpg.SlackBuild
--- slackware64-current/source/l/libwpg/libwpg.SlackBuild	2023-05-01 20:52:35.450840064 +0200
+++ slackware64-current.2/source/l/libwpg/libwpg.SlackBuild	2025-01-07 13:31:27.772875030 +0100
@@ -84,8 +84,13 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+if [ -z "$TARGET" ]; then
+  TARGET=$ARCH-slackware-linux
+fi
+
 CFLAGS="$SLKCFLAGS" \
 CXXFLAGS="$SLKCFLAGS" \
+LDFLAGS="$SLKLDFLAGS" \
 ./configure \
   --prefix=/usr \
   --libdir=/usr/lib${LIBDIRSUFFIX} \
@@ -93,8 +98,8 @@
   --localstatedir=/var \
   --docdir=/usr/doc/$PKGNAM-$VERSION \
   --disable-static \
-  --build=$ARCH-slackware-linux \
-  --host=$ARCH-slackware-linux || exit 1
+  --build=$TARGET \
+  --host=$TARGET || exit 1
 
 make $NUMJOBS || make || exit 1
 make install-strip DESTDIR=$PKG || exit 1
diff -ur slackware64-current.2/source/l/mozilla-nss/mozilla-nss.SlackBuild slackware64-current.3/source/l/mozilla-nss/mozilla-nss.SlackBuild
--- slackware64-current.2/source/l/mozilla-nss/mozilla-nss.SlackBuild	2024-11-22 20:57:42.508010256 +0100
+++ slackware64-current.3/source/l/mozilla-nss/mozilla-nss.SlackBuild	2025-01-07 13:31:27.882880914 +0100
@@ -55,7 +55,6 @@
 elif [ "$ARCH" = "x86_64" ]; then
   SLKCFLAGS="-O2 -march=x86-64 -mtune=generic -fPIC"
   LIBDIRSUFFIX="64"
-  export USE_64=1
 else
   SLKCFLAGS="-O2"
   LIBDIRSUFFIX=""
@@ -66,6 +65,11 @@
 
 NUMJOBS=${NUMJOBS:-" -j $(expr $(nproc) + 1) "}
 
+if [ "$LIBDIRSUFFIX" = "64" -o `gcc -dM -E - < /dev/null | grep -c LP64.*1` -gt 0 ]
+then
+  export USE_64=1
+fi
+
 rm -rf $PKG
 mkdir -p $TMP $PKG
 
@@ -88,8 +92,23 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+EXTRA_NSS=""
+if [ "$ARCH" = "ppc64" ]
+then
+  # PowerPC64 (big-endian) porting is compiled to support POWER4: disabling POWER8 assembler
+  # and vsx crypto instructions 
+  #zcat $CWD/ppc64-disable-power8-asm.diff.gz | patch -p1 --verbose || exit 1
+  EXTRA_NSS="-Ddisable_crypto_vsx=1"
+elif [ "$ARCH" = "i586" ]
+then
+  EXTRA_NSS="-m32"
+fi
+
+# Add Alpha architecture to 64 bit pool:
+zcat $CWD/newarch_use_nss_64.diff.gz | patch -p1 --verbose || exit 1
+
 cd nss
-./build.sh -v $NUMJOBS --opt --system-sqlite --enable-libpkix --disable-tests
+./build.sh -v $NUMJOBS --opt --system-sqlite --enable-libpkix --disable-tests $EXTRA_NSS
 cd -
 
 # Install all the needed stuff to the package dir:
diff -ur slackware64-current.2/source/l/mozjs140/mozjs140.SlackBuild slackware64-current.3/source/l/mozjs140/mozjs140.SlackBuild
--- slackware64-current.2/source/l/mozjs140/mozjs140.SlackBuild	2024-09-17 19:13:23.764008450 +0200
+++ slackware64-current.3/source/l/mozjs140/mozjs140.SlackBuild	2024-10-30 11:02:16.038933536 +0100
@@ -57,6 +57,7 @@
 if [ "$ARCH" = "i686" ]; then
   SLKCFLAGS="-O2 -march=pentium4 -mtune=generic"
   LIBDIRSUFFIX=""
+  EXTRACONF="--target=$ARCH-slackware-linux --host=$ARCH-slackware-linux"
 elif [ "$ARCH" = "x86_64" ]; then
   SLKCFLAGS="-O2 -march=x86-64 -mtune=generic -fPIC"
   LIBDIRSUFFIX="64"
@@ -104,6 +105,27 @@
 # Remove bundled zlib directory and use system version:
 rm -rf modules/zlib
 
+# Restore i686 compile patch (without you need at least pentium4 ARCH):
+# Fix header mismatch on x86 with GCC:
+if [ "$ARCH" = "i686" ]; then
+  zcat $CWD/double_t.x86.diff.gz | patch -p1 --verbose || exit 1
+fi
+
+# Build big-endian data file for ppc, ppc64, mips, and s390:
+( cd config/external/icu/data ; icupkg -tb icu*l.dat `basename icu*l.dat l.dat`b.dat )
+# Fix incorrect specific arm atomic include for jitless-ARMv5:
+if [ "$ARCH" = "arm" ]; then
+  zcat $CWD/patches/atomic_armv5.diff.gz | patch -p1 --verbose || exit 1
+fi
+# Fix unimplmented armv5 asm instruction:
+zcat $CWD/patches/armv5_disable_asm.diff.gz | patch -p1 --verbose || exit 1
+# Cannot build rustc with s390x (segmentation fault), fix script to use prebuild: 
+if [ "$ARCH" = "s390x" ]; then
+  zcat $CWD/patches/rustup_s390x.diff.gz | patch -p1 --verbose || exit 1
+fi
+# Fix unexported js::detail::CanonicalizedNaNBits on mips64el
+zcat  $CWD/patches/Export-js-detail-CanonicalizedNaNBits-on-architectures-th.patch.gz | patch -p1 --verbose || exit 1
+
 cd js/src
 
 # We need to do this because patches above touch configure.in:
@@ -111,7 +131,7 @@
 
 CFLAGS+="$SLKCFLAGS -fno-delete-null-pointer-checks -fno-strict-aliasing -fno-tree-vrp " \
 CXXFLAGS+="$SLKCFLAGS -fno-delete-null-pointer-checks -fno-strict-aliasing -fno-tree-vrp " \
-LDFLAGS="-Wl,--copy-dt-needed-entries" \
+LDFLAGS="-Wl,--copy-dt-needed-entries $SLKLDFLAGS" \
 ./configure \
   --prefix=/usr \
   --libdir=/usr/lib${LIBDIRSUFFIX} \
@@ -128,8 +149,19 @@
   --disable-debug \
   --enable-pie \
   --disable-jemalloc \
+  $EXTRACONF \
   --build=$ARCH-slackware-linux \
 
+# Fix linker on ppc64:
+# /usr/bin/clang -std=gnu99 -o nsinstall_real -DXP_UNIX -O3 -fuse-ld=lld host_nsinstall.o host_pathsub.o
+# ld.lld: error: /usr/bin/../lib64/gcc/ppc64-slackware-linux/14.1.0/../../../../lib64/Scrt1.o: ABI version 1 is not supported
+if [ "$ARCH" = "ppc64" ]; then
+  sed -i 's/fuse-ld=lld/fuse-ld=ld/' config/autoconf.mk
+fi
+
+# Add executable stack to nsinstall_real:
+sed -i 's/\(COMPUTED_HOST_C_LDFLAGS +=\)/\1 -z execstack/' config/backend.mk
+
 make $NUMJOBS || make || exit 1
 make install DESTDIR=$PKG || exit 1
 
diff -ur slackware64-current.2/source/l/nodejs/nodejs.SlackBuild slackware64-current.3/source/l/nodejs/nodejs.SlackBuild
--- slackware64-current.2/source/l/nodejs/nodejs.SlackBuild	2024-11-20 20:29:55.111795279 +0100
+++ slackware64-current.3/source/l/nodejs/nodejs.SlackBuild	2025-01-07 13:31:28.102892682 +0100
@@ -80,6 +80,13 @@
 sed -i "s|'lib'|'lib${LIBDIRSUFFIX}'|g" lib/module.js
 sed -i "s|'lib'|'lib${LIBDIRSUFFIX}'|g" deps/npm/lib/npm.js
 
+## Fix various non-x86 architectures:
+for p in $CWD/patches/*.diff.gz
+do
+  zcat $p | patch --verbose -p1 || exit 1
+done
+
+
 # Not sure if this one is really needed.
 #sed -i "s|math.h|cmath|" src/node_crypto.cc
 
diff -ur slackware64-current.2/source/l/openblas/openblas.SlackBuild slackware64-current.3/source/l/openblas/openblas.SlackBuild
--- slackware64-current.2/source/l/openblas/openblas.SlackBuild	2025-03-13 10:36:52.931729846 +0100
+++ slackware64-current.3/source/l/openblas/openblas.SlackBuild	2025-05-06 15:21:20.715396097 +0200
@@ -47,7 +47,10 @@
 fi
 
 # Don't include -j for this package.
-NUMJOBS=${NUMJOBS:-"$(expr $(nproc) + 1)"}
+NUMJOBS=${NUMJOBS:-"-j $(expr $(nproc) + 1)"}
+JOBS=`echo "$NUMJOBS" | sed 's/.*-j *//'`
+
+EXTRACONF="DYNAMIC_ARCH=1"
 
 # If you passed in a NUMJOBS with the -j, we're just going to use 4 jobs.
 # I've observed the compile hanging when run massively parallel with icecream.
@@ -79,6 +86,32 @@
 tar xf $CWD/$SRCNAM-$VERSION.tar.?z || exit 1
 cd $SRCNAM-$VERSION || exit 1
 
+if [ "$ARCH" != "x86_64" -a "$ARCH" != "i586" ]
+then
+  # utests failed on architectures different than x86. Disable them:
+  zcat $CWD/disable_utest.diff.gz | patch -p1 --verbose || exit 1
+fi
+if [ "$ARCH" = "alpha" -o "$ARCH" = "ppc64" -o "$ARCH" = "mips64el" ]
+then
+  # ctest failed on alpha. Disable them:
+  zcat $CWD/disable_ctest.diff.gz | patch -p1 --verbose || exit 1
+fi
+if [ "$ARCH" = "mips64el" ]
+then
+  # Compilation needs Loongson3 instructions:
+  export QEMU_CPU=Loongson-3A4000
+fi
+# ARMVx not set, automatically detect by __ARM_ARCH:
+zcat $CWD/arm_arch_definition.diff.gz | patch -p1 --verbose || exit 1
+
+# Set generic kernel for arm, powerpc, and alpha:
+(cd kernel/x86
+ for a in arm power alpha
+ do
+   \cp -p KERNEL.generic ../$a
+ done
+)
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
@@ -95,10 +118,10 @@
 # Build:
 make \
   PREFIX=/usr \
-  MAKE_NB_JOBS=${NUMJOBS} \
+  MAKE_NB_JOBS=${JOBS} \
   OPENBLAS_LIBRARY_DIR=/usr/lib$LIBDIRSUFFIX \
   TARGET=$TARGET \
-  DYNAMIC_ARCH=1 \
+  $EXTRACONF \
   NO_STATIC=1 \
   USE_THREAD=1 \
   NUM_THREADS=64 \
@@ -112,10 +135,10 @@
 # Install:
 make \
   PREFIX=/usr \
-  MAKE_NB_JOBS=${NUMJOBS} \
+  MAKE_NB_JOBS=${JOBS} \
   OPENBLAS_LIBRARY_DIR=/usr/lib$LIBDIRSUFFIX \
   TARGET=$TARGET \
-  DYNAMIC_ARCH=1 \
+  $EXTRACONF \
   NO_STATIC=1 \
   USE_THREAD=1 \
   NUM_THREADS=64 \
diff -ur slackware64-current.2/source/l/opencv/opencv.SlackBuild slackware64-current.3/source/l/opencv/opencv.SlackBuild
--- slackware64-current.2/source/l/opencv/opencv.SlackBuild	2021-10-02 10:49:52.075396075 +0200
+++ slackware64-current.3/source/l/opencv/opencv.SlackBuild	2025-08-29 11:51:13.243428974 +0200
@@ -51,6 +51,8 @@
 
 NUMJOBS=${NUMJOBS:-" -j $(expr $(nproc) + 1) "}
 
+CMAKE_EXTRA=""
+
 if [ "$ARCH" = "i686" ]; then
   SLKCFLAGS="-O2 -march=pentium4 -mtune=generic"
   LIBDIRSUFFIX=""
@@ -81,6 +81,10 @@
 
 tar xvf $CWD/${PKGNAM}_contrib-${VERSION}.tar.?z || exit 1
 
+# HPPA wants structure that cares memory locking aligned to 16 bytes.
+# Skip static assertion 'static_assert(alignof(T) <= 8, "");' on HPPA:
+zcat $CWD/disable_protobuf_static_assert.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
@@ -100,6 +100,7 @@
     -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
     -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
     -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    $CMAKE_EXTRA \
     -DCMAKE_BUILD_TYPE="Release" \
     -DCMAKE_INSTALL_PREFIX=/usr \
     -DINSTALL_MAN_DIR=man \
diff -ur slackware64-current.2/source/l/opus/opus.SlackBuild slackware64-current.3/source/l/opus/opus.SlackBuild
--- slackware64-current.2/source/l/opus/opus.SlackBuild	2021-10-02 2024-04-06 20:29:00.969838645 +0200
+++ slackware64-current.3/source/l/opus/opus.SlackBuild	2023-07-07 2024-04-11 10:36:17.472676211 +0200
@@ -70,6 +70,11 @@
 TMP=${TMP:-/tmp}
 PKG=$TMP/package-$PKGNAM
 
+case "$ARCH" in
+  i?86|x86_64|armv7hl|aarch64)
+    EXTRACONF="-Dintrinsics=enabled -Drtcd=enabled" ;;
+esac
+
 rm -rf $PKG
 mkdir -p $TMP $PKG
 
@@ -106,8 +111,7 @@
   --localstatedir=/var \
   --buildtype=release \
   -Dcustom-modes=true \
-  -Drtcd=enabled \
-  -Dintrinsics=enabled \
+  $EXTRACONF \
   -Ddocdir=/usr/doc/opus-$VERSION \
   .. || exit 1
   "${NINJA:=ninja}" $NUMJOBS || exit 1
diff -ur slackware64-current.2/source/l/pcre/pcre.SlackBuild slackware64-current.3/source/l/pcre/pcre.SlackBuild
--- slackware64-current.2/source/l/pcre/pcre.SlackBuild	2021-06-16 20:06:20.130041857 +0200
+++ slackware64-current.3/source/l/pcre/pcre.SlackBuild	2021-09-18 13:42:55.527028876 +0200
@@ -46,6 +46,8 @@
 
 NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
 
+ENABLE_JIT="--enable-jit"
+
 if [ "$ARCH" = "i586" ]; then
   SLKCFLAGS="-O2 -march=i586 -mtune=i686"
   LIBDIRSUFFIX=""
@@ -87,7 +89,7 @@
   --enable-utf8 \
   --enable-pcre16 \
   --enable-pcre32 \
-  --enable-jit \
+  $ENABLE_JIT \
   --enable-unicode-properties \
   --enable-pcregrep-libz \
   --enable-pcregrep-libbz2 \
diff -ur slackware64-current.2/source/l/pcre2/pcre2.SlackBuild slackware64-current.3/source/l/pcre2/pcre2.SlackBuild
--- slackware64-current.2/source/l/pcre2/pcre2.SlackBuild	2021-05-27 20:13:43.502030635 +0200
+++ slackware64-current.3/source/l/pcre2/pcre2.SlackBuild	2025-02-08 17:33:10.639656726 +0100
@@ -50,6 +50,8 @@
 TMP=${TMP:-/tmp}
 PKG=$TMP/package-$PKGNAM
 
+ENABLE_JIT="--enable-jit"
+
 if [ "$ARCH" = "i686" ]; then
   SLKCFLAGS="-O2 -march=pentium4 -mtune=generic"
   LIBDIRSUFFIX=""
@@ -88,7 +90,7 @@
   --enable-static=no \
   --enable-pcre2-16 \
   --enable-pcre2-32 \
-  --enable-jit \
+  $ENABLE_JIT \
   --enable-pcre2grep-libz \
   --enable-pcre2grep-libbz2 \
   --enable-pcre2test-libreadline \
diff -ur slackware64-current.2/source/l/phonon/phonon.SlackBuild slackware64-current.3/source/l/phonon/phonon.SlackBuild
--- slackware64-current.2/source/l/phonon/phonon.SlackBuild	2024-04-06 20:28:38.148622105 +0200
+++ slackware64-current.3/source/l/phonon/phonon.SlackBuild	2025-02-17 11:30:43.003467821 +0100
@@ -111,8 +114,11 @@
 
 # Build for Qt5:
 build_phonon 5
+# No more needed (successfully compiled qt6 without webengine), but leave it as option.
+if [ -f /usr/bin/qmake6 ]; then
 # Build for Qt6:
 build_phonon 6
+fi
 
 # Make sure the Qt6 designer plugin is in the proper directory:
 if [ -r $PKG/usr/lib${LIBDIRSUFFIX}/qt5/plugins/designer/phonon4qt6widgets.so ]; then
diff -ur slackware64-current.2/source/l/poppler/poppler.SlackBuild slackware64-current.3/source/l/poppler/poppler.SlackBuild
--- slackware64-current.2/source/l/poppler/poppler.SlackBuild	2024-04-06 20:28:40.018721799 +0200
+++ slackware64-current.3/source/l/poppler/poppler.SlackBuild	2024-04-07 21:16:01.527973848 +0200
@@ -47,6 +47,11 @@
 
 NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
 
+# No more needed (successfully compiled qt6 without webengine), but leave it as option.
+if [ ! -f /usr/bin/qmake6 ]; then
+  QT6OPT="-DENABLE_QT6=OFF"
+fi
+
 if [ "$ARCH" = "i686" ]; then
   SLKCFLAGS="-O2 -march=pentium4 -mtune=generic"
   LIBDIRSUFFIX=""
diff -ur slackware64-current.2/source/l/protobuf/protobuf.SlackBuild slackware64-current.3/source/l/protobuf/protobuf.SlackBuild
--- slackware64-current.2/source/l/protobuf/protobuf.SlackBuild	2025-05-06 12:42:21.057567907 +0200
+++ slackware64-current.3/source/l/protobuf/protobuf.SlackBuild	2025-07-14 23:13:04.453010909 +0200
@@ -72,6 +76,9 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Disable PROTOBUF_MUSTTAIL on s390x:
+zcat $CWD/disable_musttail.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
@@ -85,6 +85,7 @@
 mkdir cmake-build
 cd cmake-build
   cmake \
+    $CMAKE_EXTRA \
     -DCMAKE_C_FLAGS="$SLKCFLAGS" \
     -DCMAKE_CXX_FLAGS="$SLKCFLAGS" \
     -DCMAKE_INSTALL_PREFIX=/usr \
diff -ur slackware64-current.2/source/l/pulseaudio/pulseaudio.SlackBuild slackware64-current.3/source/l/pulseaudio/pulseaudio.SlackBuild
--- slackware64-current.2/source/l/pulseaudio/pulseaudio.SlackBuild	2024-11-30 20:35:26.886937225 +0100
+++ slackware64-current.3/source/l/pulseaudio/pulseaudio.SlackBuild	2025-01-07 13:31:29.632974521 +0100
@@ -95,6 +95,9 @@
 zcat $CWD/ed3d4f0837f670e5e5afb1afa5bcfc8ff05d3407.patch.gz | patch -p1 --verbose || exit 1
 zcat $CWD/f5cacd94abcc47003bd88ad7ca1450de649ffb15.patch.gz | patch -p1 --verbose || exit 1
 
+# Fixing time64 on 32 bit systems for padsp (should not be defined):
+zcat $CWD/padsp_disable_time64.diff.gz | patch -p1 --verbose || exit 1
+
 # Configure, build, and install:
 export CFLAGS="$SLKCFLAGS"
 export CXXFLAGS="$SLKCFLAGS"
diff -ur slackware64-current.2/source/l/qt5/qt5.SlackBuild slackware64-current.3/source/l/qt5/qt5.SlackBuild
--- slackware64-current.2/source/l/qt5/qt5.SlackBuild	2024-11-23 21:45:41.120058790 +0100
+++ slackware64-current.3/source/l/qt5/qt5.SlackBuild	2025-01-07 13:31:29.742980405 +0100
@@ -117,6 +117,21 @@
 cd - 1>/dev/null
 cd qtwebengine
   zcat $CWD/patches/qt5-qtwebengine-gcc11.patch.gz | patch -p1 --verbose || exit 1
+  zcat $CWD/patches/qtwebengine-mips-ppc-riscv-s390-support.diff.gz | patch -p1 --verbose || exit 1
+  zcat $CWD/patches/qtwebengine-mips32-limit-mksnapshot-memory.diff.gz | patch -p1 --verbose || exit 1
+  zcat $CWD/patches/qtwebengine-bigendian.diff.gz | patch -p1 --verbose || exit 1
+  zcat $CWD/patches/qtwebengine-time64_disable_zlib.diff.gz | patch -p1 --verbose || exit 1
+  tar xvf $CWD/patches/qtwebengine-mips-ppc-riscv-s390-newfiles.tar.gz
+  if [ "${ARCH::3}" = "ppc" -o "$ARCH" = "mips64el" -o "$ARCH" = "riscv64" -o "$ARCH" = "s390x" ]
+  then
+    # Disable getcontext on breakpad (missing assembler):
+    zcat $CWD/patches/qtwebengine-nogetcontext.diff.gz | patch -p1 --verbose || exit 1
+  fi
+  if [ "$ARCH" = "mips" -o "$ARCH" = "mipsel" ]
+  then
+    # Add atomic linking for mips 32-bits architecture
+    sed -i 's/LIBS_PRIVATE += /LIBS_PRIVATE += -latomic /' src/tools/qwebengine_convert_dict/qwebengine_convert_dict.pro
+  fi
 cd - 1>/dev/null
 
 # Fix build with gcc12:
@@ -177,6 +192,22 @@
   unset FFMPEG_OPTION
 fi
 
+if [ "$ARCH" = "arm" ]; then
+  # Fix incorrect target cpu (armv7 instead of armv5) for qtwebengine
+  # and remove the use of thumb2 instructions (not present on armv5)
+  zcat $CWD/patches/qtwebengine-armv5.patch.gz | patch -p1 --verbose || exit 1
+fi
+
+# Add s390x/loongarch support to qtscript (JSVALUE64: error: cast from 'QTJSC::JSCell*' to 'int32_t' {aka 'int'} loses precision [-fpermissive])
+zcat $CWD/patches/qt5.qtscript.s390x_loongarch_support.diff.gz | patch -p1 --verbose || exit 1
+# Add loongarch in the list of "correct" double conversion architectures:
+zcat $CWD/patches/qt5.doubleconversion_correct.diff.gz | patch -p1 --verbose || exit 1
+
+if [ `gcc -dM -E - < /dev/null | grep -c '__BYTE_ORDER__.*__ORDER_BIG_ENDIAN__'` -gt 0 ]; then
+  # Fix incorrect icudt(littleendian).dat file
+  sed -i 's/icudtl.dat/icudtb.dat/' qtwebengine/src/core/core_module.pro
+fi
+
 export CFLAGS="$SLKCFLAGS"
 export CXXFLAGS="$SLKCFLAGS"
 export OPENSOURCE_CXXFLAGS="$SLKCFLAGS"
@@ -236,12 +267,17 @@
 # Strip binaries:
 find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
 
+# Removing RPATHS from uic broke the binary that generate invalid "->addSubWindow()" call,
+# but only for mips architecture. On riscv64, removing RPATHS lead to 
+if [ "$ARCH" != "mips" ]
+then
 # Remove rpaths:
 for file in $(find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF | cut -f 1 -d : 2> /dev/null) ; do
   if [ ! "$(patchelf --print-rpath $file 2> /dev/null)" = "" ]; then
     patchelf --remove-rpath $file
   fi
 done
+fi
 
 # Don't ship .la files:
 rm -f $PKG/usr/lib${LIBDIRSUFFIX}/*.la
diff -ur slackware64-current.2/source/l/qt6/qt6.SlackBuild slackware64-current.3/source/l/qt6/qt6.SlackBuild
--- slackware64-current.2/source/l/qt6/qt6.SlackBuild	2024-12-02 22:58:07.591216457 +0100
+++ slackware64-current.3/source/l/qt6/qt6.SlackBuild	2025-08-05 12:23:05.649563393 +0200
@@ -65,10 +65,17 @@
   SLKCFLAGS="$OPTS32"
   SLKLDFLAGS=""
   LIBDIRSUFFIX=""
+  EXTRA="-DFEATURE_no_direct_extern_access=ON"
 elif [ "$ARCH" = "x86_64" ]; then
   SLKCFLAGS="-O2 -march=x86-64 -mtune=generic -fPIC"
   SLKLDFLAGS="-L/usr/lib64"
   LIBDIRSUFFIX="64"
+  EXTRA="-DFEATURE_no_direct_extern_access=ON"
+elif [ "$ARCH" = "i586" ]; then
+  SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+  SLKLDFLAGS=""
+  LIBDIRSUFFIX=""
+  EXTRA="-DFEATURE_no_direct_extern_access=ON"
 else
   SLKCFLAGS="-O2"
   SLKLDFLAGS=""
@@ -85,6 +92,11 @@
     *)    TARGET=$ARCH-slackware-linux ;;
 esac
 
+case "$ARCH" in
+    arm|riscv64|ppc*|mips*|sh4|hppa|or1k|alpha|sparc*|loongarch64|s390x) QTWEBENGINE="NO" ;;
+    *) QTWEBENGINE="YES" ;;
+esac
+
 # For cross-compiling from x86_64:
 if [ "$(uname -m)" = "x86_64" -a "$(file -L /usr/bin/gcc | grep 386 | grep 32-bit)" != "" ]; then
   ARCH=i686
@@ -100,7 +110,7 @@
 fi
 
 # Use ld.bfd linker (default) on x86 32-bit, and mold elsewhere:
-if [ "$ARCH" = "i686" ]; then
+if [ "$ARCH" = "i686" -o "$ARCH" = "i586" -o "$ARCH" = "ppc64" -o "${ARCH::4}" = "mips" -o "$ARCH" = "alpha" -o "$ARCH" = "aarch64" ]; then
   LINKEROPT=" "
 else
   LINKEROPT="-DFEATURE_use_mold_linker=ON"
@@ -152,6 +164,13 @@
 pushd qtwebengine
   # Thanks Debian! See https://salsa.debian.org/qt-kde-team/qt6/qt6-webengine/-/tree/master/debian/patches
   cat $CWD/patches/qt6-webengine_32bit_compressing_files.patch | patch -p1 --verbose || exit 1
+
+  # Add BonSlack architecture support
+  zcat $CWD/patches/qtwebengine-disable_time64_for_gz.diff.gz | patch -p1 --verbose || exit 1
+  zcat $CWD/patches/qtwebengine-disable-v8-unit-tests.diff.gz | patch -p1 --verbose || exit 1
+  zcat $CWD/patches/qtwebengine-newarchs.diff.gz | patch -p1 --verbose || exit 1
+  zcat $CWD/patches/qtwebengine-disable-zlib_arm_neon.diff.gz | patch -p1 --verbose || exit 1
+  zcat $CWD/patches/qtwebengine-arm_neonfp16arith.diff.gz | patch -p1 --verbose || exit 1
 popd
 cat $CWD/patches/nodejs-allow-32bit.patch | patch -p1 --verbose || exit 1
 
@@ -175,8 +194,8 @@
 
 # The qtquick3dphysics only compiles on a limited set of architectures:
 case "${ARCH}" in
-  i?86 | arm | s390) DO_PHYSX3D="OFF" ;;
-  *)                 DO_PHYSX3D="ON" ;;
+  x86_64 | aarch64 | armv7hl ) DO_PHYSX3D="ON" ;;
+  * )                          DO_PHYSX3D="OFF" ;;
 esac
 
 # Use our custom compiler and linker flags:
@@ -189,6 +208,40 @@
 # default, we'll turn it OFF. But we should test in the future to see if it
 # starts to work.
 
+if [ "$ARCH" = "arm" ]; then
+  # Fix incorrect target cpu (armv7 instead of armv5) for qtwebengine
+  # and remove the use of thumb2 instructions (not present on armv5)
+  zcat $CWD/patches/qtwebengine-armv5.patch.gz | patch -p1 --verbose || exit 1
+fi
+
+# Add loongarch/riscv/mips64 support to qtdeclarative
+zcat $CWD/patches/qtdeclarative.wtf.mips64_loongarch_riscv_support.diff.gz | patch -p1 --verbose || exit 1
+# Disabled Altivec and VSX instruction on PPC (32 bit):
+zcat $CWD/patches/qtmultimedia_disable_altivec_on_ppc.diff.gz | patch -p1 --verbose || exit 1
+# Add sh4/openrisc support to qtbase (elf):
+zcat $CWD/patches/openrisc_sh4_support.diff.gz | patch -p1 --verbose || exit 1
+
+if [ `gcc -dM -E - < /dev/null | grep -c '__BYTE_ORDER__.*__ORDER_BIG_ENDIAN__'` -gt 0 ]; then
+  # Fix incorrect icudt(littleendian).dat file
+  for f in qtwebengine/src/core/api/Qt6WebEngineCoreDeploySupport.cmake \
+           qtwebengine/src/core/api/CMakeLists.txt \
+	   qtwebengine/src/core/tools/main.cpp 
+  do
+    sed -i 's/icudtl.dat/icudtb.dat/' $f
+  done
+fi
+
+if [ "$QTWEBENGINE" = "NO" ]; then
+  rm -rf qtwebengine  
+  QTWEBOPTS=""
+else
+  QTWEBOPTS="-DFEATURE_webengine_proprietary_codecs=${USE_CODECS} \
+  -DFEATURE_webengine_system_ffmpeg=${SYSTEM_FFMPEG} \
+  -DFEATURE_webengine_system_pulseaudio=${USE_PULSEAUDIO} \
+  -DFEATURE_webengine_webrtc_pipewire=ON"
+fi
+
+export LANG=en_US.UTF-8
 export CFLAGS="$SLKCFLAGS"
 export CXXFLAGS="$SLKCFLAGS"
 export OPENSOURCE_CXXFLAGS="$SLKCFLAGS"
@@ -216,16 +269,13 @@
   -DINSTALL_DOCDIR=/usr/doc/qt6-${PKGVER} \
   -DINSTALL_EXAMPLESDIR=/usr/doc/qt6-${PKGVER}/examples \
   -DFEATURE_libproxy=ON \
-  -DFEATURE_no_direct_extern_access=ON \
+  $EXTRA \
   -DFEATURE_openssl_linked=ON \
   -DFEATURE_pulseaudio="${USE_PULSEAUDIO}" \
   -DFEATURE_system_sqlite=ON \
   -DFEATURE_system_xcb_xinput=ON \
   $LINKEROPT \
-  -DFEATURE_webengine_proprietary_codecs="${USE_CODECS}" \
-  -DFEATURE_webengine_system_ffmpeg="${SYSTEM_FFMPEG}" \
-  -DFEATURE_webengine_system_pulseaudio="${USE_PULSEAUDIO}" \
-  -DFEATURE_webengine_webrtc_pipewire=ON \
+  $QTWEBOPTS \
   -DFEATURE_quick3dxr_openxr:BOOL=OFF \
   -DFEATURE_system_openxr:BOOL=OFF \
   $PROTOBUF \
diff -ur slackware64-current.2/source/l/sdl/sdl.SlackBuild slackware64-current.3/source/l/sdl/sdl.SlackBuild
--- slackware64-current.2/source/l/sdl/sdl.SlackBuild	2021-09-07 20:59:04.419006899 +0200
+++ slackware64-current.3/source/l/sdl/sdl.SlackBuild	2021-09-18 13:42:55.767040991 +0200
@@ -97,6 +97,7 @@
   --disable-esd \
   --enable-shared=yes \
   --enable-static=no \
+  $SVGA \
   --disable-x11-shared || exit 1
 
 make $NUMJOBS || make || exit 1
diff -ur slackware64-current.2/source/l/speexdsp/speexdsp.SlackBuild slackware64-current.3/source/l/speexdsp/speexdsp.SlackBuild
--- slackware64-current.2/source/l/speexdsp/speexdsp.SlackBuild	2021-02-13 06:32:03.250945004 +0100
+++ slackware64-current.3/source/l/speexdsp/speexdsp.SlackBuild	2021-09-18 13:42:55.767040991 +0200
@@ -88,7 +88,7 @@
   --mandir=/usr/man \
   --docdir=/usr/doc/$PKGNAM-$VERSION \
   --enable-static=no \
-  --build=$ARCH-slackware-linux || exit 1
+  $EXTRACONF --build=$ARCH-slackware-linux || exit 1
 
 make $NUMJOBS || make || exit 1
 make install DESTDIR=$PKG || exit 1
diff -ur slackware64-current.2/source/l/startup-notification/startup-notification.SlackBuild slackware64-current.3/source/l/startup-notification/startup-notification.SlackBuild
--- slackware64-current.2/source/l/startup-notification/startup-notification.SlackBuild	2022-10-06 13:46:55.979938328 +0200
+++ slackware64-current.3/source/l/startup-notification/startup-notification.SlackBuild	2025-06-09 20:42:00.201245137 +0200
@@ -69,6 +74,10 @@
 rm -rf startup-notification-$VERSION
 tar xvf $CWD/startup-notification-$VERSION.tar.xz || exit 1
 cd startup-notification-$VERSION || exit 1
+
+# Patch to fix support for time64 on 32 bit platforms:
+zcat $CWD/sn-monitor_time64.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/l/v4l-utils/v4l-utils.SlackBuild slackware64-current.3/source/l/v4l-utils/v4l-utils.SlackBuild
--- slackware64-current.2/source/l/v4l-utils/v4l-utils.SlackBuild	2010-08-09 23:14:43.000000000 +0200
+++ slackware64-current.3/source/l/v4l-utils/v4l-utils.SlackBuild	2017-12-08 14:49:40.096583760 +0100
@@ -71,6 +71,17 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Disable _TIME_BITS=64 (not useful and in conflict on v4l2convert.c):
+#zcat $CWD/disable_time64.diff.gz | patch -p1 --verbose || exit 1
+# v4l2-tracer did not link with _TIME_BITS=64, disabling it for the whole package:
+# Update (2024-07-23): moving _TIME_BITS=64 to features.h seem to solve the problem.
+#                      Leave this note until all works fine.
+#SLKCFLAGS="$SLKCFLAGS -D_DONOTFORCE_TIME_BITS"
+#if [ "$LIBDIRSUFFIX" = "" -a `gcc -dM -E - < /dev/null | grep -c LP64.*1` -eq 0  ]; then
+#  # You have to disable tracer if you want _TIME_BITS=64
+#  TRACER="--disable-v4l2-tracer"
+#fi
+
 # Make sure ownerships and permissions are sane:
 chown -R root:root .
 find . \
diff -ur slackware64-current.2/source/l/vte/vte.SlackBuild slackware64-current.3/source/l/vte/vte.SlackBuild
--- slackware64-current.2/source/l/vte/vte.SlackBuild	2024-10-30 10:01:08.266560589 +0100
+++ slackware64-current.3/source/l/vte/vte.SlackBuild	2024-12-09 09:22:47.556920123 +0100
@@ -78,6 +78,9 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+# Fix missing FE_INVALID on or1k:
+zcat $CWD/fe_invalid_not_def.diff.gz | patch -p1 --verbose || exit 1
+
 # Configure, build, and install:
 export CFLAGS="$SLKCFLAGS"
 export CXXFLAGS="$SLKCFLAGS"
diff -ur slackware64-current.2/source/l/zlib/zlib.SlackBuild slackware64-current.3/source/l/zlib/zlib.SlackBuild
--- slackware64-current.2/source/l/zlib/zlib.SlackBuild	2021-02-13 06:32:03.250945004 +0100
+++ slackware64-current.3/source/l/zlib/zlib.SlackBuild	2021-09-18 13:42:55.767040991 +0200
@@ -81,7 +81,7 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
-CFLAGS="$SLKCFLAGS" \
+CFLAGS="$SLKCFLAGS -D_DONOTFORCE_TIME_BITS" \
 ./configure \
   --prefix=/usr \
   --libdir=/usr/lib${LIBDIRSUFFIX} \
diff -ur slackware64-current.2/source/n/curl/curl.SlackBuild slackware64-current.3/source/n/curl/curl.SlackBuild
--- slackware64-current.2/source/n/curl/curl.SlackBuild	2021-05-29 19:23:09.213002935 +0200
+++ slackware64-current.3/source/n/curl/curl.SlackBuild	2021-09-18 13:42:55.837044524 +0200
@@ -80,7 +86,11 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+# Adding missing #include <sched.h>
+zcat $CWD/sched_yield-missing_include.diff.gz | patch -p1 --verbose || exit 1
+
 CFLAGS="$SLKCFLAGS" \
+LDFLAGS="$SLKLDFLAGS" \
 ./configure \
   --prefix=/usr \
   --libdir=/usr/lib${LIBDIRSUFFIX} \
diff -ur slackware64-current.2/source/n/dhcp/dhcp.SlackBuild slackware64-current.3/source/n/dhcp/dhcp.SlackBuild
--- slackware64-current.2/source/n/dhcp/dhcp.SlackBuild	2021-05-29 19:23:09.213002935 +0200
+++ slackware64-current.3/source/n/dhcp/dhcp.SlackBuild	2021-09-18 13:42:55.837044524 +0200
@@ -85,6 +85,9 @@
 # Add PATH setting to /sbin/dhclient-script
 zcat $CWD/dhclient-script.PATH.diff.gz | patch -p1 || exit 1
 
+# Add build-aux scripts for riscv64:
+(cd bind; zcat $CWD/bind-build-aux-Makefile.patch.gz | patch --verbose)
+
 # Fix paths in manual pages
 sed -i \
     -e "s,ETCDIR,/etc,g" \
@@ -95,6 +99,7 @@
     doc/*/*.{5,8}
 
 CFLAGS="$SLKCFLAGS" \
+LDFLAGS="$SLKLDFLAGS" \
 ./configure \
   --prefix=/usr \
   --sysconfdir=/etc \
